// Compile with clang -o tester tester.m -framework Foundation -framework CoreGraphics -framework AppKit
#include <Foundation/Foundation.h>
#include <Foundation/NSURL.h>
#include <dlfcn.h>
#include <stdint.h>
#include <sys/shm.h>
#include <dirent.h>

#import <Cocoa/Cocoa.h>
#import <ImageIO/ImageIO.h>

int main(int argc, const char * argv[]) {
    if (argc < 2) {
        printf("Usage: %s path/to/image\n", argv[0]);
        return 0;
    }

    /*const size_t sz = 0x10000;
    char* chunks[64];
    for (int i = 0; i < 64; i++) {
        char* chunk = mmap(0, sz, PROT_READ | PROT_WRITE, MAP_ANONYMOUS | MAP_PRIVATE, -1, 0);
        memset(chunk, 0x41, sz);
        NSLog(@"Chunk @ %p", chunk);
        chunks[i] = chunk;
    }

    for (int i = 0; i < 64; i += 2) {
        munmap(chunks[i], sz);
    }*/

    NSString* path = [NSString stringWithUTF8String:argv[1]];
    NSData* content = [NSData dataWithContentsOfFile:path];
    NSImage* img = [[NSImage alloc] initWithData:content];
    NSLog(@"Image @ %p: %@\n", img, img);

    CGImageRef cgImg = [img CGImageForProposedRect:nil context:nil hints:nil];
    if (cgImg) {
        size_t width = CGImageGetWidth(cgImg);
        size_t height = CGImageGetHeight(cgImg);
        CGColorSpaceRef colorspace = CGColorSpaceCreateDeviceRGB();
        CGContextRef ctx = CGBitmapContextCreate(0, width, height, 8, 0, colorspace, 1);
        CGRect rect = CGRectMake(0, 0, width, height);
        CGContextDrawImage(ctx, rect, cgImg);

        CGColorSpaceRelease(colorspace);
        CGContextRelease(ctx);
        CGImageRelease(cgImg);
    }

    /*for (int i = 1; i < 64; i += 2) {
        if (*chunks[i] != 0x41) {
            int l = 0;
            for (; l < sz; l++) {
                if (chunks[i][l] == 0x41) {
                    break;
                }
            }
            NSLog(@"Overflowed (probably) %i bytes into chunk %i (%p)", l, i, chunks[i]);
            break;
        }
    }*/


    [img release];
    [content release];
    [path release];

    return 0;
}
